import neopixel
import audiobusio
import digitalio
import audioio
import time
from board import *

def kontarbour(np):
    """ Affiche un compte a rebours sur les NeoPixels."""
    # Debute dans un etat "off".
    np.fill((0, 0, 0))
    np.write()
    for i in range(10):
        np[i] = (0, 20, 0)
        np.write()
        time.sleep(0.5)
    np.fill((0, 128, 0))
    np.write()

def enregistrer():
    """ Renvoie un tampon contenant l'enregistrement."""
    buf = bytearray(8000)
    with audiobusio.PDMIn(MICROPHONE_CLOCK, MICROPHONE_DATA) as mic:
        mic.record(buf, len(buf))
    return buf

def relire(buf, freq):
    """
    Lit le contenu du tampon a une certaine frequence.
    """
    # Prepare le haut-parleur.
    speaker_enable = digitalio.DigitalInOut(SPEAKER_ENABLE)
    speaker_enable.switch_to_output(value = True)
    # Lit le tampon.
    with audioio.AudioOut(SPEAKER, buf) as hp:
        hp.frequency = freq
        hp.play()
        # Bloque pendant la lecture.
        while hp.playing:
            pass

neopixels = neopixel.NeoPixel(NEOPIXEL, 10, auto_write=False)
boutA = digitalio.DigitalInOut(BUTTON_A)
boutA.pull = digitalio.Pull.DOWN
boutB = digitalio.DigitalInOut(BUTTON_B)
boutB.pull = digitalio.Pull.DOWN

kontarbour(neopixels)
tamponAudio = enregistrer()
neopixels.fill((0, 0, 0))
neopixels.write()

freq = 8000       # Par defaut = vitesse normale
if boutA.value:
    freq = 12000  # Bouton A = dessin anime.
elif boutB.value:
    freq = 6000   # Bouton B = Barry White.

relire(tamponAudio, freq)
