import array
import pulseio
import board

# Table de conversion entre caracteres et Morse
TAB_CAR_MORSE = {
    "A": ".-",
    "B": "-...",
    "C": "-.-.",
    "D": "-..",
    "E": ".",
    "F": "..-.",
    "G": "--.",
    "H": "....",
    "I": "..",
    "J": ".---",
    "K": "-.-",
    "L": ".-..",
    "M": "--",
    "N": "-.",
    "O": "---",
    "P": ".--.",
    "Q": "--.-",
    "R": ".-.",
    "S": "...",
    "T": "-",
    "U": "..-",
    "V": "...-",
    "W": ".--",
    "X": "-..-",
    "Y": "-.--",
    "Z": "--..",
    "1": ".----",
    "2": "..---",
    "3": "...--",
    "4": "....-",
    "5": ".....",
    "6": "-....",
    "7": "--...",
    "8": "---..",
    "9": "----.",
    "0": "-----",
}

def encoder(msg):
    mots = msg.split(' ')
    tampon_msg = []
    for mot in mots:
        tampon_msg.extend([8000, 8000, ])      # Nouveau mot
        for carac in mot:
            tampon_msg.extend([4000])          # Nouveau caractere
            for val in TAB_CAR_MORSE[carac]:
                if val == '-':
                    tampon_msg.extend([2000])  # Trait.
                else:
                    tampon_msg.extend([1000])  # Point.
    if mots:
        tampon_msg.extend([8000, 8000, ])      # Fin de message
    return array.array('H', tampon_msg)


ir_led = pulseio.PWMOut(board.REMOTEOUT, frequency=38000, duty_cycle=2**15)
ir_out = pulseio.PulseOut(ir_led)
message = encoder("HELLO WORLD")
ir_out.send(message)
