import radio
from microbit import *

radio.config(length=64)
radio.on()

nom_carte = "Salon"

messages = [
  "La TV est disponible.",
  "Du bois pour faire du feu.",
  "Pensez a nettoyer l'insert.",
  "Une flambee ferait du bien !",
  "C'est l'heure de l'apero.",
  "Oui",
  "Non",
]

cache_msg = {}
duree_cache = 1000 * 5  # Soit 5 secondes

position = 0

while True:
    sleep(20)
    # Vide le cache de messages
    heure_actu = running_time()
    tab_msgobso = []
    # Balayage
    for cle, heure_msg in cache_msg.items():
        # Teste l'age du message dans le cache
        if heure_actu > heure_msg + duree_cache:
            tab_msgobso.append(cle)
    # Supprime les vieux messages
    for stale_message in tab_msgobso:
        del cache_msg[stale_message]
    # Change de message actuel
    if button_a.was_pressed():
        position += 1
        # Revient en debut de liste si a la fin
        if position == len(messages):
            position = 0
        # Affiche le nouveau message actuel
        display.scroll(messages[position], 50, wait=False)
    # Envoie le message actuel.
    if button_b.was_pressed():
        # Le format est "carte:contenu".
        radio.send('{}:{}'.format(nom_carte, messages[position]))
    # Attend et affiche message entrant, et rediffuse
    msg = radio.receive()
    if msg:
        if msg not in cache_msg:
            # Nouveau message, donc le stocker
            cache_msg[msg] = running_time()
            # Le rediffuser
            radio.send(msg)
            # L'afficher en defilement
            sender, message = msg.split(':')
            display.scroll('{} dit: {}'.format(sender,message), 50, wait=False)
