"""
Se place en coute d'une micro:bit et ragit aux messages reus.
"""
from serial.tools.list_ports import comports as list_serial_ports
from serial import Serial

def trouver_mic():
    """
    Cherche le port de l'appareil connect.
    """
    ports = list_serial_ports()
    for port in ports:
        # Identifie la carte avec le fournisseur et l'ID produit
        if "VID:PID=0D28:0204" in port[2].upper():
            return port[0]
    return None

def obtenir_serial():
    """
    Scrute une carte micro:bit et renvoie un objet serial pour lui parler.
    """
    port = trouver_mic()
    if port is None:
        raise IOError('Carte micro:bit introuvable.')
    return Serial(port, 115200, timeout=1, parity='N')

serial = obtenir_serial()  # Etablit la connexion srie avec la micro:bit.

# Rceptionne des octets et les affiche
while True:
    msg = serial.read_all()  # msg contient des octets, pas une chane
    if msg:
        # Ici, vous pouvez scruter msg pour ragir de faon
        # plus prcise, par exemple en utilisant
        # serial.write(a_reponse) pour le rediffuser.
        print(msg)
