# 1102_CPX_metronome.py
import neopixel
import audioio
import digitalio
import array
import time
from board import *

np = neopixel.NeoPixel(NEOPIXEL, 10)
moinsvite      = digitalio.DigitalInOut(BUTTON_A)
moinsvite.pull = digitalio.Pull.DOWN
plusvite       = digitalio.DigitalInOut(BUTTON_B)
plusvite.pull  = digitalio.Pull.DOWN

longueur = 8000 // 1760
onde = array.array("H", [0] * longueur)
onde[0] = int(2 ** 16 - 1)

hp_actif = digitalio.DigitalInOut(SPEAKER_ENABLE)
hp_actif.switch_to_output(value=True)

hp = audioio.AudioOut(SPEAKER, onde)
duree_blip  = 0.02
tempo_moyen = 0.48
tempo = tempo_moyen
changement_tempo = 0.02

while True:
    if moinsvite.value and plusvite.value:
        tempo = tempo_moyen
    elif moinsvite.value:
        tempo = min(tempo + changement_tempo, 2.98)
    elif plusvite.value:
        tempo = max(tempo - changement_tempo, 0.02)
    np.fill((0, 255, 0))
    np.write()
    hp.play(loop=True)
    time.sleep(duree_blip)
    hp.stop()
    np.fill((0, 0, 0))
    np.write()
    time.sleep(tempo)
