import audioio
import digitalio
import array
import time
from board import SPEAKER, SPEAKER_ENABLE

# Activation du haut-parleur
hp_actif = digitalio.DigitalInOut(SPEAKER_ENABLE)
hp_actif.switch_to_output(value=True)

notes = {
  'b': 493,
  'a#': 466,
  'a': 440,
  'g#': 415,
  'g': 392,
  'f#': 370,
  'f': 347,
  'e': 330,
  'd#': 311,
  'd': 294,
  'c#': 277,
  'c': 262,
}

def bruire(hauteur, duree):
    longueur = 8000 // hauteur
    onde = array.array("H", [0] * longueur)
    onde[0] = int(2 ** 16 - 1)
    with audioio.AudioOut(SPEAKER, onde) as hp:
        hp.play(loop=True)
        time.sleep(duree - 0.01)
        hp.stop()
        time.sleep(0.01)  # Petit silence

def jouer(partoche):
    for note in partoche:
        nom, duree = note.split(':')
        bruire(notes[nom], int(duree) / 8)

ligne1 = ['c:4', 'd:4', 'e:4', 'c:4']
ligne2 = ['e:4', 'f:4', 'g:8']
ligne3 = ['g:2', 'a:2', 'g:2', 'f:2', 'e:4', 'c:4']
ligne4 = ['c:4', 'g:4', 'c:8']
frere_jacques = ligne1 * 2 + ligne2 * 2 + ligne3 * 2 + ligne4 * 2

jouer(frere_jacques)
