import audioio
import digitalio
import time
import array
import math
from board import SPEAKER, SPEAKER_ENABLE

hp_actif = digitalio.DigitalInOut(SPEAKER_ENABLE)
hp_actif.switch_to_output(value=True)

long = 8000 // 440
sinus    = array.array("H", [0] * long)
triangle = array.array("H", [0] * long)
dan2si   = array.array("H", [0] * long)
carre    = array.array("H", [0] * long)

# Production des formes d'onde
for i in range(long):
    sinus[i] = int(math.sin(math.pi * 2 * i / long) * (2 ** 15 - 1) + (2 ** 15))
    triangle[i] = abs(int(i * ((2 ** 15 - 1) // long)) - 2 ** 14)
    dan2si[i]   = int(i * ((2 ** 15 - 1) // long))
    if i < long // 2:
        carre[i] = (2 ** 16 -1)

# Lecture
print("Sinus")
with audioio.AudioOut(SPEAKER, sinus) as echanti:
    echanti.play(loop=True)
    time.sleep(2)
    echanti.stop()

print("Triangle")
with audioio.AudioOut(SPEAKER, triangle) as echanti:
    echanti.play(loop=True)
    time.sleep(2)
    echanti.stop()

print("Dents de scie (Sawtooth)")
with audioio.AudioOut(SPEAKER, dan2si) as echanti:
    echanti.play(loop=True)
    time.sleep(2)
    echanti.stop()

print("Carr")
with audioio.AudioOut(SPEAKER, carre) as echanti:
    echanti.play(loop=True)
    time.sleep(2)
    echanti.stop()
