import speech
from microbit import sleep, button_a, button_b, display, Image

gap = 220   # Longueur d'un silence
bass_drum = "BUH"  # Son de grosse caisse de beatbox
snare = "CHIXIX"   # Son d'une caisse claire de beatbox
roll = "DGDG"  # Son d'un fla de batterie beatbox
pause = ""     # Pause de longueur "gap"

# Deux sequences (des listes). Un temps par ligne
motif1 = [         # Cool
    bass_drum, pause, pause, pause,
    snare, pause, pause, pause,
    bass_drum, bass_drum, bass_drum, pause,
    snare, pause, roll, roll,
]

motif2 = [         # Hardcore
    bass_drum, snare, snare, snare,
    bass_drum, snare, roll, roll,
    bass_drum, bass_drum, bass_drum, snare,
    bass_drum, roll, roll, bass_drum,
]

# Joue un son ou un silence
def beat_box(son):
    if son:
        display.show(Image.HEART)
        sleep(10)
        display.clear()
        speech.pronounce(son)
    else:
        sleep(gap)

# Lit tous les sons de la sequence
def lire(seq):
    for top in seq:
        beat_box(top)

choix = motif1  # Sequence initiale

# Reboucle sur une sequence
while True:
    # Choix de sequence avec boutons A et B
    if button_a.was_pressed():
        choix = motif1
    elif button_b.was_pressed():
        choix = motif2
    # Lecture de la sequence
    lire(choix)
