import microbit

class Servo:
    def __init__(self, broche, trim=0):
        self.pin = broche
        self.trim = trim
        self.speed = 0
        self.pin.set_analog_period(20)

    def reguler(self, vite):
        self.pin.write_analog(int(25 + 100 * (90 + vite) / 180 + self.trim))
        self.speed = vite


class Robot:
    def __init__(self):
        # Penser a ajuster les valeurs de trim.
        self.servo_g = Servo(microbit.pin0, 2)
        self.servo_d = Servo(microbit.pin1, 1)

    def avancer(self, distance):
        microbit.display.show(microbit.Image.ARROW_S)
        self.servo_g.reguler(-90)
        self.servo_d.reguler(90)
        microbit.sleep(int(distance * 2000 / 17))
        self.stopper()

    def tourner(self, angle):
        if angle > 0:
            microbit.display.show(microbit.Image.ARROW_E)
            self.servo_g.reguler(-90)
            self.servo_d.reguler(-90)
            microbit.sleep(int(angle * 64 / 9))
        else:
            microbit.display.show(microbit.Image.ARROW_W)
            self.servo_g.reguler(90)
            self.servo_d.reguler(90)
            microbit.sleep(int(-angle * 64 / 9))
        self.stopper()

    def stopper(self):
        microbit.display.show(microbit.Image.DIAMOND)
        self.servo_g.reguler(0)
        self.servo_d.reguler(0)

    def regarder(self):
        return microbit.pin2.read_analog()


robot = Robot()
while True:
    robot.avancer(5)
    if robot.regarder() > 700:
        robot.tourner(20)
        distance_g = robot.regarder()
        robot.tourner(-40)
        distance_d = robot.regarder()
        robot.tourner(20)
        if distance_g < distance_d:
            robot.tourner(60)
        else:
            robot.tourner(-60)
