# Emetteur Bit:Bot
from microbit import *
import radio

radio.config(channel=44)
radio.on()

# Limites des mesures d'inclinaison
max_tilt = 1000
min_tilt = 199

while True:
    # Lecture des capteurs
    y = accelerometer.get_y()   # Avant / Arriere
    x = accelerometer.get_x()   # Gauche / Droite
    a = button_a.was_pressed()  # Klaxon
    b = button_b.was_pressed()  # Lumieres

    # Data de pilotage a envoyer
    # [vitesse, direction, bruiteur, neopixels]
    bloc_commande = [0, 0, 0, 0]
    if x < -min_tilt and y < -min_tilt:
        # En avant gauche
        display.show(Image.ARROW_NW)
        bloc_commande[0] = max(y, -max_tilt)
        bloc_commande[1] = max(x, -max_tilt)
    elif x < -min_tilt and y > min_tilt:
        # En arriere gauche
        display.show(Image.ARROW_SW)
        bloc_commande[0] = min(y, max_tilt)
        bloc_commande[1] = max(x, -max_tilt)
    elif x > min_tilt and y < -min_tilt:
        # En avant droite
        display.show(Image.ARROW_NE)
        bloc_commande[0] = max(y, -max_tilt)
        bloc_commande[1] = min(x, max_tilt)
    elif x > min_tilt and y < min_tilt:
        # En arriere droite
        display.show(Image.ARROW_SE)
        bloc_commande[0] = min(y, max_tilt)
        bloc_commande[1] = min(x, max_tilt)
    elif y > min_tilt:
        # En arriere
        display.show(Image.ARROW_S)
        bloc_commande[0] = min(y, max_tilt)
    elif y < -min_tilt:
        # En avant
        display.show(Image.ARROW_N)
        bloc_commande[0] = max(y, -max_tilt)
    if a:
        # Klaxonner
        bloc_commande[2] = 1
    if b:
        # Allumer/eteindre LED
        bloc_commande[3] = 1
    if any(bloc_commande):
        msg = '{}:{}:{}:{}'.format(*bloc_commande)
        radio.send(msg)
    else:
        display.clear()
    sleep(20)
