# Recepteur
from microbit import *
import radio
import neopixel

display.show(Image.SKULL)  # Logo cranien :-)

couleur = (244, 0, 244)  # Couleur des LED NeoPixels
np = neopixel.NeoPixel(pin13, 12)
lumiere = False

radio.config(channel=44)
radio.on()

def bouger(vitesse, braquage):
    # On part d'une position stop
    enavant = 0
    gauche  = 0
    droite  = 0
    if vitesse > 0:
        # En avant toute
        enavant = 1
        gauche = 1000 - vitesse
        droite = 1000 - vitesse
    elif vitesse < 0:
        # Marche arriere
        gauche = 1000 + (-1000 - vitesse)
        droite = 1000 + (-1000 - vitesse)
    if braquage < 0:
        # A droite
        droite = min(1000, droite + abs(braquage))
        gauche = max(0,    gauche - abs(braquage))
    elif braquage > 0:
        # A gauche
        gauche = min(1000, gauche + braquage)
        droite = max(0,    droite - braquage)

    # Envoi des ordres aux moteurs
    pin8.write_digital(enavant)
    pin12.write_digital(enavant)
    pin0.write_analog(gauche)
    pin1.write_analog(droite)

while True:
    pin14.write_digital(0)  # Arret du klaxon
    try:
        msg = radio.receive()
    except:
        msg = None  # Attention aux reseaux inconnus
    if msg is not None:
        # Extraction des donnees du message
        vitesse, braquage, klax, lumi = [int(val) for val in msg.split(':')]
        bouger(vitesse, braquage)  # On se bouge
        if klax:
            # Coup de klaxon
            pin14.write_digital(1)
        if lumi:
            # Inversion lumieres
            if lumiere:
                np.clear()
                lumiere = False
            else:
                lumiere = True
                for i in range(12):
                    np[i] = couleur
                    np.show()
    else:
        # Pas de message ? On ne fait rien !
        bouger(0, 0)
    sleep(20)
